package cop

/*
The COP struct is the base for all collections of protocols, it does not implement the COPer interface itself, because it shouldn't be instantiated at all, only in it's specializations.
*/

import "gitea.mmo.to/ppForge/ppforge/protocol"

// COP represents the base for Collection of Protocols
type COP struct {
	Type      string
	Protocols map[string]ProtocolCollectionEntry
	closed    bool
}

// ProtocolCollectionEntry is a single entry in the file database, additionally to the meta data the path is required
type ProtocolCollectionEntry struct {
	Path     string
	Protocol protocol.Meta
}

// A collection entry has a path, which is meant to be a filesystem path, but doesn't necessarily have to be.
// If a collection is implemented as a database, this could also be the unique id. It is there to uniquely identify the entry.
